> ## Documentation Index
> Fetch the complete documentation index at: https://developers.telnyx.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create Insight Template

> Create a new insight



## OpenAPI

````yaml /openapi/source/external/inference/inference-embedding.json post /ai/conversations/insights
openapi: 3.1.0
info:
  version: 2.0.0
  title: Telnyx API
  x-latency-category: responsive
  x-endpoint-cost: light
  description: SIP trunking, SMS, MMS, Call Control and Telephony Data Services.
  contact:
    email: support@telnyx.com
servers:
  - url: https://api.telnyx.com/v2
    description: Version 2.0.0 of the Telnyx API
security:
  - bearerAuth: []
tags:
  - name: Chat
    description: Generate text with LLMs
  - name: Assistants
    description: Configure AI assistant specifications
  - name: Conversations
    description: Manage historical AI assistant conversations
  - name: File-based Text-to-Speech
    description: Turn audio into text or text into audio.
  - name: Embeddings
    description: Embed documents and perform text searches
  - name: Clusters
    description: Identify common themes and patterns in your embedded documents
  - name: Fine Tuning
    description: Customize LLMs for your unique needs
  - name: OpenAI Embeddings
    description: >-
      OpenAI-compatible embeddings endpoints for generating vector
      representations of text
paths:
  /ai/conversations/insights:
    post:
      tags:
        - Conversations
      summary: Create Insight Template
      description: Create a new insight
      operationId: create_insight
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/InsightTemplateCreateReq'
            example:
              instructions: Instructions
              name: Name
              webhook: ''
              json_schema: string
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/InsightTemplateDetailRespData'
              example:
                data:
                  id: 3fa85f64-5717-4562-b3fc-2c963f66afa6
                  instructions: Instructions
                  created_at: '2024-01-23T18:10:02.574Z'
                  insight_type: custom
                  name: ''
                  webhook: ''
                  json_schema: string
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      x-codeSamples:
        - lang: JavaScript
          source: >-
            import Telnyx from 'telnyx';


            const client = new Telnyx({
              apiKey: process.env['TELNYX_API_KEY'], // This is the default and can be omitted
            });


            const insightTemplateDetail = await
            client.ai.conversations.insights.create({
              instructions: 'instructions',
              name: 'name',
            });


            console.log(insightTemplateDetail.data);
        - lang: Python
          source: |
            import os
            from telnyx import Telnyx

            client = Telnyx(
                api_key=os.environ.get("TELNYX_API_KEY"),  # This is the default and can be omitted
            )
            insight_template_detail = client.ai.conversations.insights.create(
                instructions="instructions",
                name="name",
            )
            print(insight_template_detail.data)
        - lang: Go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/team-telnyx/telnyx-go\"\n\t\"github.com/team-telnyx/telnyx-go/option\"\n)\n\nfunc main() {\n\tclient := telnyx.NewClient(\n\t\toption.WithAPIKey(\"My API Key\"),\n\t)\n\tinsightTemplateDetail, err := client.AI.Conversations.Insights.New(context.TODO(), telnyx.AIConversationInsightNewParams{\n\t\tInstructions: \"instructions\",\n\t\tName:         \"name\",\n\t})\n\tif err != nil {\n\t\tpanic(err.Error())\n\t}\n\tfmt.Printf(\"%+v\\n\", insightTemplateDetail.Data)\n}\n"
        - lang: Java
          source: >-
            package com.telnyx.sdk.example;


            import com.telnyx.sdk.client.TelnyxClient;

            import com.telnyx.sdk.client.okhttp.TelnyxOkHttpClient;

            import
            com.telnyx.sdk.models.ai.conversations.insights.InsightCreateParams;

            import
            com.telnyx.sdk.models.ai.conversations.insights.InsightTemplateDetail;


            public final class Main {
                private Main() {}

                public static void main(String[] args) {
                    TelnyxClient client = TelnyxOkHttpClient.fromEnv();

                    InsightCreateParams params = InsightCreateParams.builder()
                        .instructions("instructions")
                        .name("name")
                        .build();
                    InsightTemplateDetail insightTemplateDetail = client.ai().conversations().insights().create(params);
                }
            }
        - lang: Ruby
          source: >-
            require "telnyx"


            telnyx = Telnyx::Client.new(api_key: "My API Key")


            insight_template_detail =
            telnyx.ai.conversations.insights.create(instructions:
            "instructions", name: "name")


            puts(insight_template_detail)
        - lang: PHP
          source: >-
            <?php


            require_once dirname(__DIR__) . '/vendor/autoload.php';


            use Telnyx\Client;

            use Telnyx\Core\Exceptions\APIException;


            $client = new Client(apiKey: getenv('TELNYX_API_KEY') ?: 'My API
            Key');


            try {
              $insightTemplateDetail = $client->ai->conversations->insights->create(
                instructions: 'instructions',
                name: 'name',
                jsonSchema: 'string',
                webhook: 'webhook',
              );

              var_dump($insightTemplateDetail);
            } catch (APIException $e) {
              echo $e->getMessage();
            }
        - lang: CLI
          source: |-
            telnyx ai:conversations:insights create \
              --api-key 'My API Key' \
              --instructions instructions \
              --name name
components:
  schemas:
    InsightTemplateCreateReq:
      properties:
        instructions:
          type: string
          title: Instructions
        name:
          type: string
          title: Name
        webhook:
          type: string
          title: Webhook
          default: ''
        json_schema:
          anyOf:
            - type: string
            - type: object
              title: JsonSchemaObject
          title: Json Schema
          description: If specified, the output will follow the JSON schema.
      type: object
      required:
        - instructions
        - name
      title: InsightTemplateCreateReq
    InsightTemplateDetailRespData:
      properties:
        data:
          $ref: '#/components/schemas/InsightTemplateResp'
      type: object
      required:
        - data
      title: InsightTemplateDetailRespData
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
      example:
        detail:
          - loc:
              - body
              - name
            msg: Field required
            type: missing
    InsightTemplateResp:
      properties:
        id:
          type: string
          format: uuid
          title: Id
        instructions:
          type: string
          title: Instructions
        created_at:
          type: string
          format: date-time
          title: Created At
        insight_type:
          $ref: '#/components/schemas/TemplateType'
          default: custom
        name:
          type: string
          title: Name
          default: ''
        webhook:
          type: string
          title: Webhook
          default: ''
        json_schema:
          anyOf:
            - type: string
            - type: object
              title: JsonSchemaObject
          title: Json Schema
          description: If specified, the output will follow the JSON schema.
      type: object
      required:
        - id
        - instructions
        - created_at
      title: InsightTemplateResp
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
    TemplateType:
      type: string
      enum:
        - custom
        - default
      title: TemplateType
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer

````